#include <iostream>
#include <fstream>
#include <cstdlib>
#include <cmath>

#if defined(WIN32)
//#  pragma comment(linker, "/subsystem:\"windows\" /entry:\"mainCRTStartup\"")
#  include "glut.h"
#  include "glext.h"
PFNGLLOADTRANSPOSEMATRIXDPROC glLoadTransposeMatrixd;
#elif defined(__APPLE__) || defined(MACOSX)
#  include <GLUT/glut.h>
#else
#  define GL_GLEXT_PROTOTYPES
#  include <GL/glut.h>
#endif

/*
** ֥
*/
#include "glsl.h"
static GLuint shader0, shader1;
static GLint texture, cubemap;

/*
**ȥåܡ
*/
#include "Trackball.h"
static Trackball *tb1, *tb2;
static int btn;

/*
** Ȣ
*/
#include "Box.h"
static Box *box;

/*
** OBJ ե
*/
#include "Obj.h"
static Obj *obj;

/*
** ƥ
*/
#define TEXWIDTH  128                           /* ƥ */
#define TEXHEIGHT 128                           /* ƥι⤵ */
static GLuint texname[2];                       /* ƥֹ̾ */
static const char *texfile[] = {                /* ƥե̾ */
  "room2ny.raw", /*  */
  "room2nz.raw", /* ΢ */
  "room2px.raw", /*  */
  "room2pz.raw", /*  */
  "room2nx.raw", /*  */
  "room2py.raw", /*  */
};
static const int target[] = {                /* ƥΥå̾ */
  GL_TEXTURE_CUBE_MAP_NEGATIVE_Y,
  GL_TEXTURE_CUBE_MAP_NEGATIVE_Z,
  GL_TEXTURE_CUBE_MAP_POSITIVE_X,
  GL_TEXTURE_CUBE_MAP_POSITIVE_Z,
  GL_TEXTURE_CUBE_MAP_NEGATIVE_X,
  GL_TEXTURE_CUBE_MAP_POSITIVE_Y,
};

/*
** ץκ
*/
static GLuint loadShader(const char *vert, const char *frag)
{
  /* ֥Ȥκ */
  GLuint vertShader = glCreateShader(GL_VERTEX_SHADER);
  GLuint fragShader = glCreateShader(GL_FRAGMENT_SHADER);
  
  /* Υץɤ߹ */
  if (readShaderSource(vertShader, vert)) exit(1);
  if (readShaderSource(fragShader, frag)) exit(1);
  
  /* ץΥѥ롿󥯷̤ѿ */
  GLint compiled, linked;

  /* СƥåΥץΥѥ */
  glCompileShader(vertShader);
  glGetShaderiv(vertShader, GL_COMPILE_STATUS, &compiled);
  printShaderInfoLog(vertShader);
  if (compiled == GL_FALSE) {
    std::cerr << "Compile error in vertex shader." << std::endl;
    exit(1);
  }
  
  /* ե饰ȥΥץΥѥ */
  glCompileShader(fragShader);
  glGetShaderiv(fragShader, GL_COMPILE_STATUS, &compiled);
  printShaderInfoLog(fragShader);
  if (compiled == GL_FALSE) {
    std::cerr << "Compile error in fragment shader." << std::endl;
    exit(1);
  }
  
  /* ץ४֥Ȥκ */
  GLuint gl2Program = glCreateProgram();
  
  /* ֥ȤΥץؤϿ */
  glAttachShader(gl2Program, vertShader);
  glAttachShader(gl2Program, fragShader);
  
  /* ֥Ȥκ */
  glDeleteShader(vertShader);
  glDeleteShader(fragShader);
  
  /* ץΥ */
  glLinkProgram(gl2Program);
  glGetProgramiv(gl2Program, GL_LINK_STATUS, &linked);
  printProgramInfoLog(gl2Program);
  if (linked == GL_FALSE) {
    std::cerr << "Link error" << std::endl;
    exit(1);
  }

  return gl2Program;
}

/*
** 
*/
static void init(void)
{
  /* ȢΥ֥Ȥ */
  box = new Box(500.0f, 500.0f, 500.0f);

  /* OBJ եɤ߹ */
  obj = new Obj("bunny.obj");

  /* ȥåܡѥ֥Ȥ */
  tb1 = new Trackball;
  tb2 = new Trackball;

  /* ƥ̾򣲸 */
  glGenTextures(2, texname);
  
  /* ƥϥñ̤˵ͤޤƤ */
  glPixelStorei(GL_UNPACK_ALIGNMENT, 4);

  /* ¦ΩΤΥƥγơʣʬ */
  glBindTexture(GL_TEXTURE_2D, texname[0]);
  glTexImage2D(GL_TEXTURE_2D, 0, GL_RGBA, TEXWIDTH * 8, TEXHEIGHT, 0,
    GL_RGBA, GL_UNSIGNED_BYTE, 0);
  
  /* ƥɤ߹ */
  for (int i = 0; i < 6; ++i) {
    std::ifstream file;

    file.open(texfile[i], std::ios::binary);
    if (file) {
      GLubyte image[TEXHEIGHT * TEXWIDTH * 4]; // ƥɤ߹

      file.read(reinterpret_cast<char *>(image), sizeof image);
      file.close();

      /* ¦ΩΤΥƥ֤ */
      glTexSubImage2D(GL_TEXTURE_2D, 0, TEXWIDTH * i, 0, TEXWIDTH, TEXHEIGHT,
        GL_RGBA, GL_UNSIGNED_BYTE, image);

      /* 塼֥ޥåԥ󥰤Υƥγ */
      glBindTexture(GL_TEXTURE_CUBE_MAP, texname[1]);
      glTexImage2D(target[i], 0, GL_RGBA, TEXWIDTH, TEXHEIGHT, 0, 
        GL_RGBA, GL_UNSIGNED_BYTE, image);

      /* оݤ¦ΩΤΥƥ᤹ */
      glBindTexture(GL_TEXTURE_2D, texname[0]);
    }
  }
  
  /* ƥ硦̾ˡλ */
  glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_MAG_FILTER, GL_LINEAR);
  glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_MIN_FILTER, GL_LINEAR);
  
  /* ƥη֤ˡλ */
  glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_WRAP_S, GL_CLAMP_TO_EDGE);
  glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_WRAP_T, GL_CLAMP_TO_EDGE);

  /* оݤ򥭥塼֥ޥåԥ󥰤Υƥڤؤ */
  glBindTexture(GL_TEXTURE_CUBE_MAP, texname[1]);

  /* ƥ硦̾ˡλ */
  glTexParameteri(GL_TEXTURE_CUBE_MAP, GL_TEXTURE_MAG_FILTER, GL_LINEAR);
  glTexParameteri(GL_TEXTURE_CUBE_MAP, GL_TEXTURE_MIN_FILTER, GL_LINEAR);
  
  /* ƥη֤ˡλ */
  glTexParameteri(GL_TEXTURE_CUBE_MAP, GL_TEXTURE_WRAP_S, GL_CLAMP_TO_EDGE);
  glTexParameteri(GL_TEXTURE_CUBE_MAP, GL_TEXTURE_WRAP_T, GL_CLAMP_TO_EDGE);
  
  /* оݤ̵̾ƥ᤹ */
  glBindTexture(GL_TEXTURE_2D, 0);
  
  /* GLSL ν */
  if (glslInit()) exit(1);

  /* ץκ */
  shader0 = loadShader("replace.vert", "replace.frag");
  shader1 = loadShader("reflect.vert", "reflect.frag");
  
  /* uniform ѿΰ֤Ф */
  texture = glGetUniformLocation(shader0, "texture");
  cubemap = glGetUniformLocation(shader1, "cubemap");

  /*  */
  glClearColor(0.3, 0.3, 1.0, 0.0);
  glEnable(GL_DEPTH_TEST);
  glDisable(GL_CULL_FACE);
  
#if defined(WIN32)
  glLoadTransposeMatrixd =
    (PFNGLLOADTRANSPOSEMATRIXDPROC)wglGetProcAddress("glLoadTransposeMatrixd");
#endif
}

/*
** 
*/
static void scene(void)
{
  /* оݤ¦ΩΤΥƥڤؤ */
  glBindTexture(GL_TEXTURE_2D, texname[0]);
  
  /* ȢΥƥΥץŬѤ */
  glUseProgram(shader0);

  /* ƥ˥åȣꤹ */
  glUniform1i(texture, 0);

  /* Ȣ */
  glPushMatrix();
  glMultMatrixd(tb2->rotation());
  box->draw();
  glPopMatrix();

  /* оݤ򥭥塼֥ޥåԥ󥰤Υƥڤؤ*/
  glBindTexture(GL_TEXTURE_CUBE_MAP, texname[1]);

  /* 塼֥ޥåԥ󥰤ΥץŬѤ */
  glUseProgram(shader1);

  /* ƥ˥åȣꤹ */
  glUniform1i(cubemap, 0);

  /* ƥѴ˥ȥåܡ뼰βžä */
  glMatrixMode(GL_TEXTURE);
  glLoadTransposeMatrixd(tb2->rotation());
  glMatrixMode(GL_MODELVIEW);

  /* 꾯˥֥Ȥƥȥåܡ뼰βžä */
  glPushMatrix();
  glTranslated(0.0, 0.0, -200.0);
  glMultMatrixd(tb1->rotation());
  obj->draw();
  glPopMatrix();
  
  /* ƥѴ򸵤᤹ */
  glMatrixMode(GL_TEXTURE);
  glLoadIdentity();
  glMatrixMode(GL_MODELVIEW);

  /* оݤ̵̾ƥ᤹ */
  glBindTexture(GL_TEXTURE_2D, 0);
}


/****************************
** GLUT ΥХåؿ **
****************************/

static void display(void)
{
  /* ̥ꥢ */
  glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);
  
  /* ǥӥ塼Ѵ */
  glMatrixMode(GL_MODELVIEW);
  glLoadIdentity();
  
  /*  */
  scene();
  
  /* ֥Хåե */
  glutSwapBuffers();
}

static void resize(int w, int h)
{
  /* ȥåܡ뤹ϰ */
  tb1->region(w, h);
  tb2->region(w, h);
  
  /* ɥΤӥ塼ݡȤˤ */
  glViewport(0, 0, w, h);
  
  /* ƩѴλ */
  glMatrixMode(GL_PROJECTION);
  
  /* ƩѴν */
  glLoadIdentity();
  gluPerspective(60.0, (double)w / (double)h, 100.0, 500.0);
}

static void idle(void)
{
  /* ̤ؤ */
  glutPostRedisplay();
}

static void mouse(int button, int state, int x, int y)
{
  btn = button;

  switch (btn) {
  case GLUT_LEFT_BUTTON:
    if (state == GLUT_DOWN) {
      /* ȥåܡ볫 */
      tb1->start(x, y);
      glutIdleFunc(idle);
    }
    else {
      /* ȥåܡ */
      tb1->stop(x, y);
      glutIdleFunc(0);
    }
    break;
  case GLUT_RIGHT_BUTTON:
    if (state == GLUT_DOWN) {
      /* ȥåܡ볫 */
      tb2->start(x, y);
      glutIdleFunc(idle);
    }
    else {
      /* ȥåܡ */
      tb2->stop(x, y);
      glutIdleFunc(0);
    }
    break;
  default:
    break;
  }
}

static void motion(int x, int y)
{
  switch (btn) {
  case GLUT_LEFT_BUTTON:
    /* ȥåܡư */
    tb1->motion(x, y);
    break;
  case GLUT_RIGHT_BUTTON:
    /* ȥåܡư */
    tb2->motion(x, y);
    break;
  default:
    break;
  }
}

static void keyboard(unsigned char key, int x, int y)
{
  switch (key) {
  case 'q':
  case 'Q':
  case '\033':
    /* ESC  q  Q 򥿥פ齪λ */
    exit(0);
  default:
    break;
  }
}

/*
** ᥤץ
*/
int main(int argc, char *argv[])
{
  glutInit(&argc, argv);
  glutInitDisplayMode(GLUT_RGBA | GLUT_DEPTH | GLUT_DOUBLE);
  glutCreateWindow(argv[0]);
  glutDisplayFunc(display);
  glutReshapeFunc(resize);
  glutMouseFunc(mouse);
  glutMotionFunc(motion);
  glutKeyboardFunc(keyboard);
  init();
  glutMainLoop();
  return 0;
}
